;BIOS routines
.MODEL  large
public	_setmagicmode,_repbios,_newbios,_putbios,_centermode,_stuffrets
public 	_reptimer,_puttimer,_inittimer,_notimer,_resetxmode,_unblockmodes
public  	_setkeyrmp,_savekrmp,_repkrmp,_setremaps,_putkrmp,_setpmflag
public	_llredirect,_repdos,_putdos,_openredir,_readredir,_pmsetwrap
public   _storeds,_setjukebox

extrn _setarcsvga:far

.CODE



MCRTC	MACRO
	mov	ah,bl
	lodsb
	xchg	al,ah
	out	dx,ax
	inc	bl
	ENDM

MGEN	MACRO
	mov	ah,bl
	lodsb
	xchg	al,ah
	out	dx,ax
	ENDM

MATTR	MACRO
	mov	dx,3dah
	in		al,dx
	mov	dx,3c0h
	mov	al,bl
	or		al,32
	out	dx,al
	lodsb
	out	dx,al
	ENDM



INTTAB  SEGMENT AT 0H
	ORG	9H*4
KEYADDR  LABEL   DWORD
INTTAB  ENDS

INTTAB2  SEGMENT AT 0H
	ORG	10H*4
BIOSADDR  LABEL   DWORD
INTTAB2  ENDS


INTTAB3  SEGMENT AT 0H
	ORG 1cH*4
TMRADDR  LABEL   DWORD
INTTAB3  ENDS



INTTAB4  SEGMENT AT 0H
	ORG 21H*4
DOSADDR  LABEL   DWORD
INTTAB4  ENDS


_setjukebox		PROC
	ARG	jboxa:WORD

	push	bp
	mov	bp,sp

	push	ax

	jmp	pjdata
jboxactiv	dw	0
pjdata:
	mov	ax,jboxa
	mov	cs:jboxactiv,ax

	pop	ax
	pop	bp
_setjukebox		ENDP


_clrcrtcprot	PROC
	push	dx
	push	ax


	mov		dx,3d4h
	mov		al,11h
	out		dx,al
	inc		dx
	in		al,dx
	and		al,127
	mov		ah,al
	dec		dx
	mov		al,11h
	out		dx,ax

	pop		ax
	pop		dx
	ret

_clrcrtcprot	ENDP



_reptimer	PROC

		push    bp
		mov     bp,sp
		push    ax
		push    ds

		jmp     pastd2


cmdfsize	dw	0
cfgfsize	dw	0
wrapfsize	dw	0

datseg	dw ?

realcx		db	?
realcy		db	?
cmdfile		db	512	dup(0)
cfgfile		db	8192	dup(0)
wrapfile	db	512	dup(0)
TMRSAVE          DD      	?
codetostuff	db	0
coinin	db	0
keyrmp  dw  0
autoesc db	0
keyrtype	dw	0
tcount	dw	0
okpos	dw	0
okdelay	dw	?
tstate	dw	0
tsecs	dw	4
okchar	dw 	0
tsem	db	0
tmset	db	0
moddel	db	0
setnow	db	0
xmodedelay	db	?
blockall	db	0
jdelay		dw	30
inbuff		db	8192 dup(0)
inblkpos	dw	0
fndtoc		dw	0
llcapture	dw	0
tocons1		db	'to continue'
tocons2		db	'TO CONTINUE'
tocons3		db	'audio device:'
refile		db	'c:\m.tmp',0
rehandle	dw	?
start1v		db	0
start2v		db	0
escv	   	db	0
start12esc	dw	0
modewidth	db 0
modeheight	dw 0

pastd2:
		cli
		assume  ds:INTTAB3
		mov     ax,INTTAB3
		mov     ds,ax
		mov     ax,WORD PTR TMRADDR
		mov     WORD PTR cs:TMRSAVE,ax

		mov     ax,WORD PTR TMRADDR+2
		mov     WORD PTR cs:TMRSAVE+2,ax

		mov     WORD PTR TMRADDR,OFFSET _newtimer
		mov     WORD PTR TMRADDR+2,cs


		sti

		mov		al,0
		mov		cs:coinin,al
		mov		cs:autoesc,al
		pop     ds
		pop     ax
		pop     bp
		ret
_reptimer	ENDP


_setkeyrmp PROC
	ARG	valuein:WORD,rtype:WORD
	push	bp
	mov		bp,sp
	push	ax

	mov		ax,valuein
	mov 	cs:keyrmp,ax
	mov		ax,rtype
	mov 	cs:keyrtype,ax

	xor		ax,ax
	mov		cs:keyrep,al
	mov		cs:keyinp,al

	pop		ax
	pop		bp
	ret
_setkeyrmp ENDP

reptimer2	PROC

		push    bp
		mov     bp,sp
		push    ax
		push    ds

		jmp     pastd3

TMRSAVE2          DD      	?
tm2set	db 0

pastd3:
		cli
		assume  ds:INTTAB3
		mov     ax,INTTAB3
		mov     ds,ax
		mov     ax,WORD PTR TMRADDR
		mov     WORD PTR cs:TMRSAVE2,ax

		mov     ax,WORD PTR TMRADDR+2
		mov     WORD PTR cs:TMRSAVE2+2,ax

		mov     WORD PTR TMRADDR,OFFSET newtimer2
		mov     WORD PTR TMRADDR+2,cs


		sti
nosett2:
		pop     ds
		pop     ax
		pop     bp
		ret
reptimer2	ENDP

reptimer3	PROC

		push    ax
		push    ds

		jmp     pastd4

TMRSAVE3          DD      	?
tm3set	db 0

		cmp		cs:tm3set,byte ptr 0
		jne		nosett3
pastd4:
		cli
		assume  ds:INTTAB3
		mov     ax,INTTAB3
		mov     ds,ax
		mov     ax,WORD PTR TMRADDR
		mov     WORD PTR cs:TMRSAVE3,ax

		mov     ax,WORD PTR TMRADDR+2
		mov     WORD PTR cs:TMRSAVE3+2,ax

		mov     WORD PTR TMRADDR,OFFSET newtimer3
		mov     WORD PTR TMRADDR+2,cs


		sti
nosett3:
		pop     ds
		pop     ax
		ret
reptimer3	ENDP

_oldint10h	PROC
	pushf
	call	dword ptr cs:BIOSSAVE

	ret
_oldint10h	ENDP


_oldDOS proc
	pushf
	call	dword ptr cs:DOSSAVE
	ret
_oldDOS endp




_setpmflag proc
	push	ax
	push	es
	push	di

	xor		ax,ax
	push	ax
	pop		es
	mov		di,476h
	mov		ax,bx
	stosb

	mov		di,477h
	mov		ax,bx
	stosb

	pop		di
	pop		es
	pop		ax
	ret
_setpmflag endp


_pmsetwrap	proc
	push	bx

	xor		bx,bx
	call	_setpmflag
	pop		bx
	ret
_pmsetwrap endp

_resetxmode	proc
	mov		byte ptr cs:xmodedelay,byte ptr 0
	ret

_resetxmode	endp


_setmagicmode	PROC


	push	ax
	push	bx
	push	cx
	push	dx
	push	ds
	push  	es
	push	si



	jmp	pastdefs

vga256x240:
;special tweaked 256x240 mode
;3c2
db	0e3h
;3d4 0 -9
v256240htot	db 93
	db 3fh,40h,128+31
v256240hrs db	71
v256240hre db	13h
v256240vtot	db	9
	db 11h,0,64
;3d4 0ah - 0bh
	db 0,0

;3d4 10h-17h
v256240vrs	db	242
v256240vre	db	164
	db 239,020h,64,0f0h,0f2h,163
;3c4 1,4
	db 9,14


vga256x256:
;special tweaked 256x256 mode

;3c2
db	0e3h
;3d4 0 -9
v256256htot	db 93
	db 3fh,40h,128+31
v256256hrs db	71
v256256hre db	13h
v256256vtot	db	17h
v256256ovr db 29
	db 0,64
;3d4 0ah - 0bh
	db 0,0

;3d4 10h-17h
v256256vrs	db	0
v256256vre	db	2+128+16
	db 0ffh,020h,64,0,10,163
;3c4 1,4
	db 9,14




db	'Eric384x224'

vga368x224:
;special tweaked 368x224 mode (memwidth of 384)
;3c2
db	231
;3d4 0 -9
v384224htot	db 106
	db 95,94,128+30
v384224hrs db	92
v384224hre db	7
v384224vtot db	9
	db 17,0,64
;3d4 0ah - 0bh
	db 0,0

;3d4 10h-17h
v384224vrs db 235
v384224vre db 162
	db 223,48,0,226,2,227
;3c4 1,4
	db 9,6

;special tweaked 320x240 mode
vga320x240:

;3c2
db	231
;3d4 0-9
v320240htot	db  105
	db 79,79,146
v320240hrs	db	85
v320240hre	db	0
v320240vtot	db	9
	db	17
	db  0,64

;3d4 0ah-0bh
	db	0,0
;3d4 10h-17h
v320240vrs	db	242

v320240vre	db	164
	db	239,40,0,240,242,227

;3c4 1,4
	db	9,14

db	'Eric304x215'
;special tweaked 304x215 mode
vga304x215:
;3c2
db	231
;3d4 0-9
v304215htot	db  105
	db 75,75,146
v304215hrs	db	85
v304215hre	db	0
v304215vtot	db	9
	db	17
	db  0,64

;3d4 0ah-0bh
	db	0,0
;3d4 10h-17h
v304215vrs	db	225

v304215vre	db	164
	db	214,40,0,224,242,227

;3c4 1,4
	db	9,14

;special tweaked 384x256 mode
vga384x256:
;3c2
db	231
;3d4 0 -9
v384256htot	db 106
	db 95,94,128+30
v384256hrs db	92
v384256hre db	7
v384256vtot db	17h
v384256ovr	db 1dh
	db 0,64
;3d4 0ah - 0bh
	db 0,0

;3d4 10h-17h
v384256vrs db 0
v384256vre db 0a2h
	db 255,46,0,1,0ch,227
;3c4 1,4
	db 9,6



;Tweaked ArcadeOS 320x200 'NTSC' mode
vgaregs13h:
;3c2
	db	231
;3d4 0 - 9
vgahtot db 105
		 db 79,79,146
vgahrs db 85
vgahre db 31
vgavtot db 4
		  db 17,0,64
;3d4 0ah - 0bh
	db 0,0

;3d4 10h - 17h
vgavrs	db	225
vgavre	db	164
	db	199
	db	40,64
	db	201,240,163
;3c4 1,4
	 db	9,14



vgaregs3h:
;3c2
	db	231
;3d4 0 - 9
txthtot	db	105
	db	79,79,146
txthrs	db 85
txthre	db 31
txtvtot	db 4
	db	17,0,64+7
;3d4 0ah - 0bh
	db 5,7
;3d4 10h - 17h
txtvrs	db 225
txtvre	db 164
		db 199
		db 40,31
		db 219,240,163
;3c4 1,4
	db 9,2


;320x200 scanline mode for PC monitors
vgaregssl:
;3c2
	db 227
;3d4 0 - 9
scnhtot	db 95
		  db 79,79,144
scnhrs	db 85
scnhre	db 29
scnvtot db 11
		  db 17,0,64
;3d4 0ah - 0bh
	db 0,0
;3d4 10h - 17h
	db 220,164,199,40,64,201,240,163
;3c4 1,4
	db 1,14

modeset	db	?
moderej	dw	0

pastdefs:


	mov	ax,cs
	mov	ds,ax

;first things first
;clear the protection on the VGA regs

	mov	dx,3d4h
	mov	al,11h
	out	dx,al
	inc	dx
	in	al,dx
	and	al,127
	mov	ah,al
	dec	dx
	mov	al,11h
	out	dx,ax

;check which mode
	cmp	cs:modeset,13h
	je		ntextmode
	jmp	textmode
ntextmode:
;see if we need arcade monitor or scanlines
;scanlines 320 x 200
	cmp   cs:vscanlines,BYTE PTR 1
	jne	nscanl
	mov	dx,offset vgaregssl
	jmp	pgmame
nscanl:
;standard 320 x 200
;check it a bit first
;get final width
	mov	dx,3d4h
	mov	al,13h
	out	dx,al
	inc	dx
	in		al,dx
	mov	cs:modewidth,al
;get final height
;tricky bit first - overflow
	dec	dx
	mov	al,7
	out	dx,al
	inc	dx
	xor	ax,ax
	in		al,dx
	mov	dx,ax
	and	ax,2
	shl	ax,7
	mov	cs:modeheight,ax
	mov	ax,dx
	and	ax,64
	shl	ax,3
	or		ax,WORD PTR cs:modeheight
	mov	cs:modeheight,ax
;now the easy bit
	mov	dx,3d4h
	mov	al,12h
	out	dx,al
	inc	dx
	in		al,dx
	or		BYTE PTR cs:modeheight,al
;see if it's doubled
	dec	dx
	mov	al,9
	out	dx,al
	inc	dx
	in		al,dx
	and	al,1
	mov	cl,al
	shr	WORD PTR cs:modeheight,cl





	cmp	BYTE PTR cs:modewidth,BYTE PTR 32
	jne	not256x256
	cmp	WORD PTR cs:modeheight,WORD PTR 239
	jne	not256x240
	mov	dx,offset vga256x240
	jmp	pgmame

not256x240:
	cmp	WORD PTR cs:modeheight,WORD PTR 255
	jne	not256x256
	mov	dx,offset vga256x256
	jmp	pgmame

not256x256:
	cmp	BYTE PTR cs:modewidth,BYTE PTR 40
	jne	not320x240
	cmp	WORD PTR cs:modeheight,WORD PTR 239
	jne	not320x240
	mov	dx,offset vga320x240
	jmp	pgmame

not320x240:
	cmp	BYTE PTR cs:modewidth,BYTE PTR 48
	jne	not384x256
	cmp	WORD PTR cs:modeheight,WORD PTR 223
	jne	not384x224
	mov	dx,offset vga368x224
	jmp	pgmame
not384x224:
	cmp	WORD PTR cs:modeheight,WORD PTR 255
	jne	not384x256
	mov	dx,offset vga384x256
	jmp	pgmame
not384x256:
	cmp	BYTE PTR cs:modewidth,BYTE PTR 38
	jne	not304x215
	cmp	BYTE PTR cs:modeheight,BYTE PTR 214
	mov	dx,offset vga304x215
	jmp	pgmame
not304x215:
	mov	dx,offset vgaregs13h
	jmp	pgmame

textmode:
;80x24 text mode
	mov	dx,offset vgaregs3h


pgmame:



	mov	si,dx

;3c2 misc. output registers
	lodsb
	mov	dx,3c2h
	out	dx,al
;3d4 the CRTC registers
	mov	dx,3d4h
	mov	cx,10
	xor	bx,bx
crlp1:
	MCRTC
	loop	crlp1

	mov		cx,2
	mov		bl,0ah
crlpx:
	MCRTC
	loop	crlpx

	mov	cx,3
	mov	bl,10h
crlp2:
	MCRTC
	loop	crlp2
	inc		si
	inc		si

	mov	cx,2
	mov	bl,15h
crlp3:
	MCRTC
	loop	crlp3
	inc	si

;3c4 the sequencer registers
	mov	dx,3c4h
	mov	bl,1
	MGEN

;	mov	bl,4
;	MGEN



	cmp	cs:modeset,13h
	je	nosetchars


;it's a text mode - set charset to 8x8
	mov	al,02h
	mov	ah,11h
	xor	bx,bx
	mov	es,bx
	call _oldint10h

nosetchars:

	pop	si
	pop	es
	pop	ds
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret


_setmagicmode	ENDP

_storeds PROC
		ARG	dsin:WORD
		push    bp
		mov     bp,sp


		mov	ax,dsin
		mov	cs:datseg,ax

		pop	bp
		ret

_storeds ENDP

_centermode	PROC

		push   		bp
		push		ax
		push		bx
;get hrs
		mov		al,BYTE PTR cs:vgahrs

;get the center value
		mov		bl,BYTE PTR cs:vcentx
		add		al,bl
		mov		BYTE PTR cs:vgahrs,al
		mov		BYTE PTR cs:txthrs,al
		mov		BYTE PTR cs:v320240hrs,al
		mov		bl,al
		add		bl,7
		mov	    BYTE PTR cs:v384224hrs,bl
		mov	    BYTE PTR cs:v384256hrs,bl
		sub		bl,21
		mov	    BYTE PTR cs:v256240hrs,bl
		mov	    BYTE PTR cs:v256256hrs,bl

		add		al,10
		and		al,31
		mov		BYTE PTR cs:vgahre,al
		mov		BYTE PTR cs:txthre,al
		mov		BYTE PTR cs:V320240hre,al

		add		bl,10
		mov	    BYTE PTR cs:v256240hre,bl
		mov	    BYTE PTR cs:v256256hre,bl



		add		bl,21
		mov		BYTE PTR cs:v384224hre,bl
		mov		BYTE PTR cs:v384256hre,bl

;get vrs
		mov		al,BYTE PTR cs:vgavrs

;get the center value
		mov		bl,BYTE PTR cs:vcenty
		add		al,bl
		mov		BYTE PTR cs:vgavrs,al
		mov		BYTE PTR cs:txtvrs,al
		add		al,2
		and		al,15
		mov		bl,BYTE PTR cs:vgavre
		and		bl,240
		or		bl,al
		mov		BYTE PTR cs:vgavre,bl
		mov		BYTE PTR cs:txtvre,bl

;get vrs
		mov		al,BYTE PTR cs:v256240vrs

		mov		bl,BYTE PTR cs:vcenty
		add		al,bl
		mov		BYTE PTR cs:v320240vrs,al
		mov		BYTE PTR cs:v256240vrs,al
		add		al,2
		and		al,15
		mov		bl,BYTE PTR cs:v320240vre
		and		bl,240
		or		bl,al
		mov		BYTE PTR cs:v320240vre,bl
		mov		BYTE PTR cs:v256240vre,bl


;get vrs
		mov		al,BYTE PTR cs:v256256vrs
;get the center value
		mov		bl,BYTE PTR cs:vcenty
		cmp		bl,0
		jl		neg256
		add		al,bl
		mov		BYTE PTR cs:v256256vrs,al
		mov		BYTE PTR cs:v384256vrs,al
		add		al,2
		and		al,15
		mov		bl,BYTE PTR cs:v256256vre
		and		bl,240
		or		bl,al
		mov		BYTE PTR cs:v256256vre,bl
		mov		BYTE PTR cs:v384256vre,bl
neg256:

;get vrs
		mov		al,BYTE PTR cs:v384224vrs
;get the center value
		mov		bl,BYTE PTR cs:vcenty
		add		al,bl
		mov		BYTE PTR cs:v384224vrs,al
		add		al,2
		and		al,15
		mov		bl,BYTE PTR cs:v384224vre
		and		bl,240
		or		bl,al
		mov		BYTE PTR cs:v384224vre,bl


		pop		bx
		pop		ax
		pop		bp

		ret
_centermode	ENDP

_repbios	PROC

		push    bp
		mov     bp,sp
		push    ax
		push    ds


		jmp     pastd
BIOSSAVE	DD      ?
DOSSAVE		DD		?
KEYSAVE     DD		?
KEYSAVE2    DD		?
pastd:
		cli
		assume  ds:INTTAB2
		mov     ax,INTTAB2
		mov     ds,ax

		mov     ax,WORD PTR BIOSADDR
		mov     cs:WORD PTR BIOSSAVE,ax

		mov     ax,WORD PTR BIOSADDR+2
		mov     cs:WORD PTR BIOSSAVE+2,ax

		mov     WORD PTR BIOSADDR,OFFSET _newbios
		mov     WORD PTR BIOSADDR+2,cs


		sti

		pop     ds
		pop     ax
		pop     bp
		ret
_repbios	ENDP


_repdos	PROC

		push    bp
		mov     bp,sp
		push    ax
		push    ds


		cli
		assume  ds:INTTAB4
		mov     ax,INTTAB4
		mov     ds,ax

		mov     ax,WORD PTR DOSADDR
		mov     cs:WORD PTR DOSSAVE,ax

		mov     ax,WORD PTR DOSADDR+2
		mov     cs:WORD PTR DOSSAVE+2,ax

		mov     WORD PTR DOSADDR,OFFSET _newdos
		mov     WORD PTR DOSADDR+2,cs


		sti

		pop     ds
		pop     ax
		pop     bp
		ret
_repdos	ENDP


_savekrmp	PROC

		push    ax
		push	ds

		cli
		assume  ds:INTTAB
		mov     ax,INTTAB
		mov     ds,ax
		mov     ax,WORD PTR KEYADDR
		mov     cs:WORD PTR KEYSAVE,ax

		mov     ax,WORD PTR KEYADDR+2
		mov     cs:WORD PTR KEYSAVE+2,ax

		sti


		pop     ds
		pop     ax
		ret
_savekrmp	ENDP


_repkrmp	PROC

		push    ax
		push	bx
		push    ds

		mov		cs:BYTE PTR keyrep,1


		assume  ds:INTTAB
		mov     ax,INTTAB
		mov     ds,ax

		mov     ax,WORD PTR KEYADDR
		cmp		ax,OFFSET _keyremap
		jne		knotdone
		mov     ax,WORD PTR KEYADDR+2
		mov		bx,cs
		cmp		ax,bx
		je		kdone
knotdone:
;save the old vector
		mov     ax,WORD PTR KEYADDR
		mov     cs:WORD PTR KEYSAVE2,ax
		mov     ax,WORD PTR KEYADDR+2
		mov     cs:WORD PTR KEYSAVE2+2,ax
		cli

;put in the new
		mov     WORD PTR KEYADDR,OFFSET _keyremap
		mov     WORD PTR KEYADDR+2,cs
		sti
kdone:




		pop     ds
		pop		bx
		pop     ax
		ret
_repkrmp	ENDP


proc setcmd
;Inputs
;bx = segment
;dx = offset
;cx = size
	push	ax
	push	es
	push	ds
	push   	si
	push	di


	push	cs
	pop		es
	mov		di,offset cmdfile


	mov		ds,bx
	mov		si,dx
	cmp		cx,512
	jl		cfit
	mov		cx,512
cfit:
	mov		cs:cmdfsize,cx

	cld
	rep		movsb

	pop		di
	pop		si
	pop		ds
	pop		es
	pop		ax

	ret
endp

proc setcfg
;Inputs
;bx = segment
;dx = offset
;cx = size
	push	ax
	push	es
	push	ds
	push   	si
	push	di


	push	cs
	pop		es
	mov		di,offset cfgfile

	mov		ds,bx
	mov		si,dx
	cmp		cx,8192
	jl			cfgfit
	mov		cx,8192
cfgfit:
	mov		cs:cfgfsize,cx

	cld
	rep		movsb


	pop		di
	pop		si
	pop		ds
	pop		es
	pop		ax

	ret
endp


proc setwrap
;Inputs
;bx = segment
;dx = offset
;cx = size
	push	ax
	push	es
	push	ds
	push   	si
	push	di

	cmp		bx,0
	jne		notwz
	mov		cs:wrapfsize,cx
	jmp		pswrap
notwz:

	push	cs
	pop		es
	mov		di,offset wrapfile

	mov		ds,bx
	mov		si,dx
	cmp		cx,512
	jl		wrapfit
	mov		cx,512
wrapfit:
	mov		cs:wrapfsize,cx

	cld
	rep		movsb
pswrap:

	pop		di
	pop		si
	pop		ds
	pop		es
	pop		ax

	ret
endp

proc getwrap
;Outputs
;bx = segment
;dx = offset
;cx = size
	mov	bx,cs
	mov	dx,offset wrapfile
	mov	cx,cs:wrapfsize
	ret
endp


proc getcmd
;Outputs
;bx = segment
;dx = offset
;cx = size
	mov	bx,cs
	mov	dx,offset cmdfile
	mov	cx,cs:cmdfsize
	ret
endp


proc getcfg
;Outputs
;bx = segment
;dx = offset
;cx = size
	mov	bx,cs
	mov	dx,offset cfgfile
	mov	cx,cs:cfgfsize
	ret
endp





_newbios	PROC
	jmp	pdata2

vscanlines	db	0
vcabinet		db	0
vcentx		db	0
vcenty		db	0
vvesa			db	1
keyrep		db	0
keyinp		db	0
pdata2:




	push	ax



	cmp	ah,0
	je		omode
	cmp	ax,4f02h
	je		omode
	jmp	nomode
omode:
	mov	BYTE PTR cs:tmset,BYTE PTR 1
nomode:



;check for our interface
	cmp	ah,0ffh
	je	internal
	jmp	nointernal
internal:
;BIOS extensions
	cmp	al,99
	jne	notcheck


;99 - check bios


	mov	bx,24
	jmp	notmode
notcheck:
	cmp	al,100
	jne	notvcab
;100 - set 'incabinet' variable
	mov	cs:vcabinet,bl
	jmp	notmode
notvcab:
	cmp	al,101
	jne	notcent
;101 - set center values
	mov	cs:vcentx,bl
	mov	cs:vcenty,bh
	call	_centermode

	jmp	notmode
notcent:
	cmp	al,102
	jne	notscan
;102 - set scanlines
	mov	cs:vscanlines,bl
	jmp	notmode
notscan:
	cmp	al,103
	jne	notvesaset
;103 - set allow vesa
	mov	cs:vvesa,bl
	jmp	notmode
notvesaset:
	cmp	al,104
	jne	nohvtotals
;104 - set h,v totals
	mov	cs:vgahtot,bl
	mov cs:txthtot,bl
	mov cs:v320240htot,bl
	mov	cs:vgavtot,bh
	mov cs:txtvtot,bh
	mov cs:v320240vtot,bh
	mov cs:v256240vtot,bh

	inc	bl
	mov	cs:v384224htot,bl
	mov	cs:v384256htot,bl
	mov	cs:v384224vtot,bh
	sub bl,13
	mov	cs:v256240htot,bl
	mov	cs:v256256htot,bl
	add bh,14
	mov cs:v256256vtot,bh
	mov cs:v384256vtot,bh

	jmp	notmode
nohvtotals:
	cmp	al,105
	jne	nohvscans
;105 - set h,v scanline totals
	mov	cs:scnhtot,bl
	mov	cs:scnvtot,bh

	jmp	notmode
nohvscans:
	cmp	al,106
	jne	nolastmode

;106 - last mode
	mov	bx,cs:moderej
	jmp	notmode
nolastmode:

	cmp	al,107
	jne	nouseresc
;107 - user escaped out of jukebox
	cmp	byte ptr cs:autoesc, byte ptr 1
	je	gotesc
	mov	bx,24
	jmp	notmode
gotesc:
	mov	bx,0
	jmp	notmode

nouseresc:
	cmp	al,108
	jne	noxmodeset
;108 - set id of xmode arcade mode
	mov BYTE PTR cs:xmodedelay,bl
;reset our 'set now' var
	mov byte ptr cs:setnow,byte ptr 0

	jmp	notmode
noxmodeset:
;109 - set blocking
	cmp	al,109
	jne	notblock

	mov	BYTE PTR cs:blockall,bl
	jmp	notmode
notblock:
;110 - set jukebox delay
	cmp	al,110
	jne	notjuke

	mov	cs:jdelay,bx
	jmp	notmode
notjuke:
;111 - set command file
	cmp	al,111
	jne	notsetcmd

	call setcmd
	jmp	notmode
notsetcmd:
;112 - set config file
	cmp	al,112
	jne	notsetcfg

	call setcfg
	jmp	notmode
notsetcfg:
;113 - set wrap file
	cmp	al,113
	jne	notsetwrap

	call setwrap
	jmp	notmode
notsetwrap:

;114 - get command file
	cmp	al,114
	jne	notgetcmd

	call getcmd
	jmp	notmode

notgetcmd:
;115 - get config file
	cmp	al,115
	jne	notgetcfg

	call getcfg
	jmp	notmode
notgetcfg:

;116 - get wrap file
	cmp	al,116
	jne	notgetwrap

	call getwrap
	jmp	notmode
notgetwrap:
nointernal:



	push	ax


	cmp	ah,0
	je		isetmode
	cmp   ah,4fh
	je		isetmode
	jmp	pgosetkey
isetmode:

	mov 	ax,cs:keyrmp
	cmp	ax,1
	jne	pgosetkey
	mov	ax,cs:keyrtype
	cmp  	ax,0
	jne	notrmset
	call 	_repkrmp
	jmp	pgosetkey
notrmset:
;call the interrupt installed by pmwrap.exe
	push	ax
	push	bx
	push	cx
	mov	ax,255
	mov	bx,ax
	mov	cx,ax
	int	18h
	pop	cx
	pop	bx
	pop	ax


pgosetkey:
	pop		ax

;see if we're setting the magic mode
	mov	al,cs:vcabinet
	or		al,cs:vscanlines
	cmp	al,0
	jne	yesarcade
	jmp	noarcade
yesarcade:

	pop	ax
;see if we're allowing vesa
	cmp	cs:vvesa,BYTE PTR 0
	jne	allowsvga

;fake 'card does not support SVGA'
	cmp	ah,4fh
	jne	allowsvga
	cmp	al,2
	jg		allowsvga
	xor	ax,ax

	iret
allowsvga:

	cmp	ah,4fh
	jne	nosvga2
	cmp	al,2
	jne	nosvga2

	call	_oldint10h

	cmp	cs:vvesa,BYTE PTR 99

	jne	nsupsvga
	push	ax
	push	ds
	mov	ax,cs:datseg
	mov	ds,ax

	call	far ptr _setarcsvga
	pop	ds
	pop	ax

nsupsvga:
	iret
nosvga2:


;check for VGA mode request
	cmp	ah,0
	je		modechg

	jmp	callold

modechg:
	push	ax


notsetkey:

	and	al,127

;supported modes
	cmp	al,13h
	je	modesup
	cmp	BYTE PTR cs:blockall,BYTE PTR 1
	je	blckall
	cmp	al,03h
	je	modesup
blckall:
	jmp	notmode
;set it to our arcade friendly mode
modesup:
	mov	cs:modeset,al
	pop	ax

	cmp	al,13h
	jne	instchg
;see if there's any delay
	cmp   byte ptr cs:xmodedelay,byte ptr 0
;there isn't, so instant
	je		instchg

	push	ax
	mov	al,cs:xmodedelay
	mov	byte ptr cs:moddel,al
	pop	ax


;delayed changed for ModeX resolutions
	call	_oldint10h
	cmp	byte ptr cs:moddel,byte ptr 99
	jne	no2pass
	mov	byte ptr cs:setnow,byte ptr 1
	iret
no2pass:
	call	reptimer2
	iret

instchg:
;instant change for standard VGA resolutions
	mov	byte ptr cs:xmodedelay,byte ptr 0
	call	_oldint10h
	call	_setmagicmode
	iret

notmode:
	pop	ax
;attempt to set another VGA mode
;which we'll block
not13h:
	iret

callold:
;any old bios call
	call	_oldint10h
	iret

noarcade:
;were not setting arcade mode
;so just call bios normally

	pop	ax
	call	_oldint10h
	iret

_newbios	ENDP

waittoxmit	proc
			push    cx
			push    ax

			xor     cx, cx
lp1:		in      al, 64h
			test    al, 2           ;Check cntrlr input buffer full flag.
			loopnz  lp1

			pop     ax
			pop     cx
			ret
waittoxmit	endp




stuffscancode proc
		push	ax
		push	bx
		push	cx

		xor     cx, cx
waitfullx:
		in      al,64h
		test    al,1
		loopnz  waitfullx

		call    waittoxmit
		mov     al, 0d2h
		out     64h, al

; Send the scan code:
		call    waittoxmit
		mov     al,bl
		out     60h,al

pat:
		pop		cx
		pop		bx
		pop		ax
		ret

stuffscancode endp


cmpstr proc
	push	bx
	push	dx
	push	di
	push	si
	mov		ax,0
cmp1:
	mov		dl,es:[si]
	cmp		dl,cs:[di]
	je		oks
	cmp		dl,cs:[bx]
	je		oks
	jmp		badend

oks:
	inc		si
	inc		di
	inc		bx
	loop	cmp1
	jmp		pbadend
badend:
	mov		ax,1
pbadend:
	pop		si
	pop		di
	pop		dx
	pop		bx
	ret
cmpstr endp

srcstr	proc
	push	ax
	push	bx
	push	cx
	push	dx
	push	di
	push	si
	push	ds
	push	es
;setup pointer to the input string

	push	ds
	pop		es
	mov		si,dx

srclp1:
;setup pointers to our 2 strings
	push	cx
	mov		cx,11
	mov		di,offset tocons1
	mov		bx,offset tocons1
	call	cmpstr
	pop		cx

	cmp		ax,0
	je		foundtoc
	inc		si
	loop	srclp1

	jmp		pfoundtoc
foundtoc:
;found our string, so hit return
	mov		cs:codetostuff,byte ptr 28
	call	reptimer3
	jmp		pfoundaud
pfoundtoc:
	mov		si,dx
srclp2:
;now check for the 'choose audio device' output
;can only happen once
;(first time AOS is run if MAME doesn't have soundcard setup)
	push	cx
	mov		cx,12
	mov		di,offset tocons3
	mov		bx,offset tocons3
	call	cmpstr
	pop		cx

	cmp		ax,0
	je		foundaud
	inc		si
	loop	srclp2

	jmp		pfoundaud
foundaud:
;found our string, no audio setup, so hit 0 (silence)
	mov		cs:codetostuff,byte ptr 11
	call	reptimer3
pfoundaud:

	pop		es
	pop		ds
	pop		si
	pop		di
	pop		dx
	pop		cx
	pop		bx
	pop		ax
	ret
srcstr	endp



newstdout proc


	push	ax
	push	cx
	push	dx
	push	ds

	cmp		cx,11
	jl		stsmall
	call	srcstr

stsmall:
	pop		ds
	pop		dx
	pop		cx
	pop		ax
;write it into our buffer

	push	bx
	push	cx
	push	di
	push	si

	mov		di,offset inbuff
	mov		bx,cs:inblkpos
	add		di,bx
	mov		si,dx
stdlp:
	mov		al,ds:[si]
	mov     cs:[di],al
	inc		si
	inc		di
	inc		bx
	cmp		bx,8196
	jne		noendb
	mov		bx,0
	mov		di,offset inbuff
noendb:
	loop	stdlp

	mov		cs:inblkpos,bx

	pop		si
	pop		di
	pop		cx
	pop		bx

	clc
	mov		ax,cx

	ret

newstdout endp

_newdos proc
	cmp		cs:llcapture,word ptr 1
	jne		nostdout


;trap writes to stdout
	cmp	ah,40h
	jne	nostdout
	cmp	bx,1
	jne	nostdout
	call	newstdout
	iret
nostdout:
;see if it's a 'setnow'
	cmp		byte ptr cs:setnow,byte ptr 1
	jne		nosetdnow

	mov		byte ptr cs:setnow,byte ptr 0
	call	_setmagicmode
nosetdnow:

	jmp dword ptr cs:DOSSAVE
_newdos endp





_keyremap	PROC
	jmp		krpast
;original scancodes
o1			db  ?
o2			db	?
o3			db	?
o4			db	?
o5			db	?
o6			db	?
o7			db	?
o8			db	?
o9			db	?
o10			db	?
o11			db	?
o12			db	?
o13			db	?
o14			db	?
o15			db	?
o16			db	?
o17			db	?
o18			db	?
o19			db	?
o20			db	?
o21			db  ?
o22			db	?
o23			db	?
o24			db	?
o25			db	?
o26			db	?
o27			db	?
o28			db	?
o29			db	?
o30			db	?
o31			db	?
o32			db	?
o33			db	?
o34			db	?
o35			db	?
o36			db	?
o37			db	?
o38			db	?
o39			db	?
o40			db	?

;new scancodes
n1			db  ?
n2			db	?
n3			db	?
n4			db	?
n5			db	?
n6			db	?
n7			db	?
n8			db	?
n9			db	?
n10			db	?
n11			db	?
n12			db	?
n13			db	?
n14			db	?
n15			db	?
n16			db	?
n17			db	?
n18			db	?
n19			db	?
n20			db	?
n21			db  ?
n22			db	?
n23			db	?
n24			db	?
n25			db	?
n26			db	?
n27			db	?
n28			db	?
n29			db	?
n30			db	?
n31			db  ?
n32			db	?
n33			db	?
n34			db	?
n35			db	?
n36			db	?
n37			db	?
n38			db	?
n39			db	?
n40			db	?
nn1			db  ?
nn2			db	?
nn3			db	?
nn4			db	?
nn5			db	?
nn6			db	?
nn7			db	?
nn8			db	?
nn9			db	?
nn10			db	?
nn11			db	?
nn12			db	?
nn13			db	?
nn14			db	?
nn15			db	?
nn16			db	?
nn17			db	?
nn18			db	?
nn19			db	?
nn20			db	?
nn21			db  ?
nn22			db	?
nn23			db	?
nn24			db	?
nn25			db	?
nn26			db	?
nn27			db	?
nn28			db	?
nn29			db	?
nn30			db	?
nn31			db  ?
nn32			db	?
nn33			db	?
nn34			db	?
nn35			db	?
nn36			db	?
nn37			db	?
nn38			db	?
nn39			db	?
nn40			db	?

noremaps	dw	?

krpast:
	push	ax
	push	bx
	push	cx
	push	di
	push	si
	push	es
;check we're not already in the middle of a remap
	mov		al,keyinp
	cmp		al,0
	je		nnkrnokeys
	dec	    BYTE PTR cs:keyinp
	jmp		krnokeys
nnkrnokeys:
;read the keyboard port
	in		al,60h
	mov     ah,al
	and     al,127
	and		ah,128


;check for start1+2=esc
	cmp		cs:start12esc,word ptr 0
	je		nostart12
	cmp		cs:escv,byte ptr 1
	je		nostart12
;start1+2=esc active, so see if start 1's been pressed
	cmp		al,2
	jne		nostart1
;check make/break
	cmp		ah,128
	jne		nos1brk
;start 1 break
	mov		cs:start1v,byte ptr 0
	jmp		nostart12
nos1brk:
;start 1 make
	mov		cs:start1v,byte ptr 1
	cmp		cs:start2v,byte ptr 1
	jne		nostart1
	mov		cs:escv,byte ptr 4
	mov		ax,1
	jmp		nostart12
nostart1:
;now check for start 2
	cmp		al,3
	jne		nostart12
;check make/break
	cmp		ah,128
	jne		nos2brk
;start 2break
	mov		cs:start2v,byte ptr 0
	jmp		nostart12
nos2brk:
;start 2 make
	mov		cs:start2v,byte ptr 1
	cmp		cs:start1v,byte ptr 1
	jne		nostart12
	mov		cs:escv,byte ptr 4
	mov		ax,1
nostart12:

;now check all the keys
	mov		cx,cs
	push	cx
	pop		es

	mov		si,offset o1
	mov		di,offset n1
	mov		cx,cs:noremaps
	cmp		cx,0
	je		krnokeys
krchklp:
	cmp		al,es:[si]
	jne		krnomatch
	mov		bl,es:[di]
	or		bl,ah
	call	stuffscancode
	inc		BYTE PTR cs:keyinp
	add		di,40
	mov		bl,es:[di]
	cmp		bl,0
	je		nosecscan
	or		bl,ah
	call	stuffscancode
	inc		BYTE PTR cs:keyinp
nosecscan:
	mov		al,20h
	out		20h,al

	cmp		cs:escv,byte ptr 4
	jne		escnoset
	mov		cs:escv,byte ptr 1
escnoset:

	pop		es
	pop		si
	pop		di
	pop		cx
	pop		bx
	pop		ax

	iret

krnomatch:
	inc		si
	inc		di
	loop		krchklp

	cmp		cs:escv,byte ptr 4
	jne		krnokeys
;stuff escape if it wasn't remapped
	mov		cs:escv,byte ptr 1
	mov		bl,1
	call	stuffscancode
	cmp		cs:start12esc,word ptr 2
	jne		noescrel1
	mov		bl,129
	call	stuffscancode
noescrel1:
	mov		al,20h
	out		20h,al


	pop		es
	pop		si
	pop		di
	pop		cx
	pop		bx
	pop		ax

	iret

krnokeys:

	cmp		cs:escv,byte ptr 4
	jne		escremapd
;stuff escape if it wasn't remapped
	mov		cs:escv,byte ptr 1
	mov		bl,1
	call	stuffscancode
	cmp		cs:start12esc,word ptr 2
	jne		noescrel2

	mov		bl,129
	call	stuffscancode
noescrel2:
	mov		al,20h
	out		20h,al


	pop		es
	pop		si
	pop		di
	pop		cx
	pop		bx
	pop		ax

	iret
escremapd:

	pop		es
	pop		si
	pop		di
	pop		cx
	pop		bx
	pop		ax

	jmp  dword ptr cs:KEYSAVE2
_keyremap	ENDP



_setremaps	PROC
	ARG		origptr:DWORD,newptr:DWORD,norscans:WORD,s12esc:WORD
	push    bp
	mov     bp,sp
	push    es
	push    ds
	push    di
	push    si
	push    ax


	xor		ax,ax
	mov		cs:start1v,al
	mov		cs:start2v,al
	mov		cs:escv,al
	mov		ax,s12esc
	mov		cs:start12esc,ax

	mov		ax,norscans

	cmp		ax,0
	jne		notkrnull
	mov		cs:noremaps,ax

	jmp		psetr
notkrnull:

	mov     ax,cs
	push	ax
	pop		es

	mov		di,OFFSET o1
	lds	  	si,origptr


;copy across original scancodes
	mov     cx,norscans
	cld
	rep     movsb

;copy across new scancodes
	mov		di,OFFSET n1
	lds	  	si,newptr
	mov		cx,norscans

	cld
	rep     movsb
;amd the 2nd scans

	mov		di,OFFSET nn1
	lds	  	si,newptr
	add		si,40
	mov		cx,norscans
	cld
	rep     movsb

;set the total
	mov		ax,norscans
	mov		cs:noremaps,ax
psetr:

	pop     	ax
	pop     	si
	pop     	di
	pop     	ds
	pop     	es
	pop     	bp
	ret

_setremaps	ENDP

_putkrmp PROC

	push  	ds
	push  	ax

	mov		al,keyrep
	cmp		al,1
	jne		keynotr

	cli
	assume	ds:INTTAB
	mov		ax,INTTAB
	mov     ds,ax


	mov	  	ax,cs:WORD PTR KEYSAVE
	mov		ds:WORD PTR KEYADDR,ax
	mov     ax,cs:WORD PTR KEYSAVE+2
	mov    	ds:WORD PTR KEYADDR+2,ax
	sti
keynotr:
	pop   	ax
	pop     ds
	ret
_putkrmp ENDP


_putbios	PROC

	push  	ds
	push  	ax

	cli
	assume	ds:INTTAB2
	mov		ax,INTTAB2
	mov     ds,ax

	mov    	ax,cs:WORD PTR BIOSSAVE
	mov     ds:WORD PTR BIOSADDR,ax
	mov		ax,cs:WORD PTR BIOSSAVE+2
	mov    	ds:WORD PTR BIOSADDR+2,ax
	sti

	pop   	ax
	pop		ds
	ret
_putbios	ENDP


_putdos	PROC

	push  	ds
	push  	ax

	cli
	assume	ds:INTTAB4
	mov		ax,INTTAB4
	mov     ds,ax

	mov    	ax,cs:WORD PTR DOSSAVE
	mov     ds:WORD PTR DOSADDR,ax
	mov		ax,cs:WORD PTR DOSSAVE+2
	mov    	ds:WORD PTR DOSADDR+2,ax
	sti

	pop   	ax
	pop		ds
	ret
_putdos	ENDP


_stuffrets PROC
	push	ax
	push	bx
	push	cx


	mov		ah,5
	mov		ch,28
	mov		cl,13
	int		16h

	mov		ah,5
	mov		ch,28
	mov		cl,13
	int		16h

	pop		cx
	pop		bx
	pop		ax
	ret
_stuffrets ENDP




_puttimer	PROC

	push	bp
	mov		bp,sp
	push  	ds
	push  	ax

	cli
	assume	ds:INTTAB3
	mov     ax,INTTAB3
	mov     ds,ax

	mov    	ax,cs:WORD PTR TMRSAVE
	mov     WORD PTR ds:TMRADDR,ax
	mov		ax,cs:WORD PTR TMRSAVE+2
	mov    	WORD PTR ds:TMRADDR+2,ax
	sti

	pop   	ax
	pop     ds
	pop     bp
	ret
_puttimer	ENDP

puttimer2	PROC

	push	bp
	mov		bp,sp
	push  	ds
	push  	ax


	cli
	assume	ds:INTTAB3
	mov     ax,INTTAB3
	mov     ds,ax

	mov    	ax,cs:WORD PTR TMRSAVE2
	mov     WORD PTR ds:TMRADDR,ax
	mov		ax,cs:WORD PTR TMRSAVE2+2
	mov    	WORD PTR ds:TMRADDR+2,ax
	sti

	mov		byte ptr cs:tm2set,0

	pop   	ax
	pop     ds
	pop     bp
	ret
puttimer2	ENDP

puttimer3	PROC

	push  	ds
	push  	ax


	cmp		byte ptr cs:tm3set,0
	jne		t3notset

	cli
	assume	ds:INTTAB3
	mov     ax,INTTAB3
	mov     ds,ax

	mov    	ax,cs:WORD PTR TMRSAVE3
	mov     WORD PTR ds:TMRADDR,ax
	mov		ax,cs:WORD PTR TMRSAVE3+2
	mov    	WORD PTR ds:TMRADDR+2,ax
	sti

	mov		byte ptr cs:tm3set,0
t3notset:
	pop   	ax
	pop     ds
	ret
puttimer3	ENDP





newtimer2	proc
	cmp		byte ptr cs:moddel,0
	je			nowset
	dec	   byte ptr cs:moddel
	jmp		dword ptr cs:TMRSAVE2

nowset:

	call	puttimer2

	call  _setmagicmode


	jmp		dword ptr cs:TMRSAVE2
newtimer2	endp

newtimer3	proc
	push	bx

	mov	bl,cs:codetostuff
	call	stuffscancode
	mov	bl,cs:codetostuff
	add	bl,128
	call	stuffscancode
	call	puttimer3
	pop	bx
	jmp	dword ptr cs:TMRSAVE3
newtimer3	endp



_newtimer	proc
	push	ax
	push	bx
	push	di
	push	es

	cli


	cmp		cs:jboxactiv,0
	je			pmnoflag

	mov		al,cs:coinin
	cmp		al,1
	jne		nocoinin
	jmp		notk

nocoinin:

;check if PM part has flagged us that a coin's been inserted
	xor		ax,ax
	push		ax
	pop		es
	mov		di,476h
	mov		al,es:[di]
	cmp		al,64
	jne		pmnoflag
	mov		al,1
	mov		cs:coinin,al


	jmp		notk
pmnoflag:
	mov		ax,cs:tstate
	mov		bx,4
;	cmp		ax,1
;	jne		nokwait
;	mov		bx,8
;	jmp		nescwait
nokwait:
;	cmp		ax,3
;	jne		nescwait
;	mov		bx,18
nescwait:


	mov		ax,cs:tcount
	inc		ax
	mov		cs:tcount,ax
	cmp		ax,bx
	jge		ok1
	jmp     	notk
ok1:
	xor		ax,ax
	mov		cs:tcount,ax

;second based - check the state
	mov		ax,cs:tstate
	cmp		ax,0
	jne		nwt
;wait for a mode change - some games take ages to load up etc

	mov		al,cs:tmset
	cmp		al,1
	jne		pnstate

	mov		ax,1
	mov		cs:tstate,ax
pnstate:
	jmp		notk
nwt:
	cmp		ax,1
	jne		nos1
;state 1 - the 'oks'

	mov		ax,cs:okchar
	cmp		ax,0
	jne		ch2

	mov		bx,24
	mov		ax,1

	jmp		ssend
ch2:
	cmp		ax,1
	jne		ch3

	mov		ax,2
	mov		bx,37
	jmp		ssend
ch3:
	cmp		ax,2
	jne		ch4
	mov		ax,3
	mov		bx,24+128
	jmp		ssend
ch4:
	mov		ax,0
	mov		bx,37+128

ssend:
	mov		cs:okchar,ax
	call		stuffscancode
;see if we've done 5 'oks'
	mov		ax,cs:okpos
	inc		ax
	mov		cs:okpos,ax
	cmp		ax,10
	je			sjp
	jmp		notk
sjp:
;we have, move onto 'press key' state
	mov		ax,2
	mov		cs:tstate,ax
	mov		ax,0
	mov		cs:okpos,ax
	jmp		notk
nos1:
	cmp		ax,2
	jne		nopress

	mov		ax,cs:okpos
	inc		ax
	mov		cs:okpos,ax
	cmp		ax,4
	jne		nofinpress
;move onto our exit state
	mov		ax,3
	mov		cs:tstate,ax
	mov		ax,cs:jdelay
	mov		cs:okdelay,ax
	mov		ax,0
	mov		cs:okchar,ax
	jmp		notk

nofinpress:
;press a few different keys, to avoid any problems
	mov		bx,36
	add		bx,ax
;	call		stuffscancode
	jmp		notk
nopress:
	cmp		ax,3
	jne		notk

;state 3 - the 'exit'
	mov		ax,cs:jboxactiv
	cmp		ax,1
	jne		notk

	mov		ax,cs:okdelay
	dec		ax
	mov		cs:okdelay,ax
	cmp		ax,0
	jne		notk

	mov		ax,3
	mov		cs:okdelay,ax
	mov		ax,cs:okchar
	cmp		ax,0
	jne		secex

	mov		ax,1
	mov		cs:okchar,ax
	mov		bx,1
	mov		cs:autoesc,bl

	call		stuffscancode
	jmp		notk

secex:
	mov		ax,4
	mov		cs:tstate,ax
	mov		bx,128+1
	call		stuffscancode

notk:

	pop		es
	pop		di
	pop		bx
	pop		ax
;call old 1ch
	sti
	jmp dword ptr cs:TMRSAVE
_newtimer	endp


_inittimer proc
		mov	WORD PTR cs:tcount,0
		mov	WORD PTR cs:okpos,0
		mov	WORD PTR cs:okdelay,2
		mov	WORD PTR cs:tstate,0
		mov	WORD PTR cs:tsecs,0
		mov	BYTE PTR cs:tsem, 0
		mov	WORD PTR cs:okchar,0
		mov	BYTE PTR cs:tmset,0
		ret
_inittimer	endp

_notimer proc
		mov	BYTE PTR cs:tmset,1
		ret
_notimer endp

_unblockmodes proc
		mov	BYTE PTR cs:blockall,BYTE PTR 0
		ret
_unblockmodes endp


_llredirect proc
	ARG	capchar:WORD
	push	bp
	mov		bp,sp
	push	ax

	xor		ax,ax
	mov		cs:fndtoc,ax

	mov		ax,capchar
	mov		cs:llcapture,ax

	pop		ax
	pop		bp
	ret
_llredirect endp

_openredir	proc
	push	ax
	xor		ax,ax
	mov		cs:inblkpos,ax
	pop		ax
	ret
_openredir	endp


_readredir	PROC
	ARG	redirptr:DWORD

	push    bp
	mov		bp,sp
	push	cx
	push	ds
	push	es
	push	di
	push	si

	mov		ax,cs
	mov		ds,ax
	mov		si,offset inbuff

	les		di,redirptr
;copy across
	mov		cx,cs:inblkpos
	cld
	rep		movsb


	mov		ax,cs:inblkpos

	pop		si
	pop		di
	pop		es
	pop		ds
	pop		cx
	pop		bp
	ret
_readredir endp


END
