#include "main.h"
#include "launch.h"

int cabonoff(int onoff)
{
   int ret=FALSE,
       port=0;
//printer hardware
// LasVegas - Added initialization for Parallel LCD
   if(PrintHardware && !(bLCDScreen && (nLCDPort>4)))	// Don't init if allready.
         _bios_printer(_PRINTER_INIT,port,0);      // 1,0,0);
   if(PrintHardware)
   {
      outp(0x378,onoff?1:2);		// Set bit0 if on, bit1 if off
      outp(0x37A,8);				// Trigger J/K
      outp(0x37A,0);				// Reset Trigger
//      if(onoff==CAB_OFF)
//         _bios_printer(_PRINTER_WRITE,port,onoff?1:2);     // 0,0,0);
//      else
//      {
//         _bios_printer(_PRINTER_WRITE,port,1);   // 0,0,255);
//         _bios_printer(_PRINTER_INIT,port,0);      // 1,0,0);
//      }
      ret=TRUE;
   }
//user defined commands
   if(ExtHardware)
   {
      if(onoff==CAB_OFF)
         userrun(szTurnOff);
      else
         userrun(szTurnOn);
      ret=TRUE;
   }
   return ret;
}

void userrun(char *userexe)
{
   char buffer[512];
   sprintf(buffer,"%s >c:\\x.tmp",userexe);
   runcommand(buffer,FALSE,FALSE,NULL,NULL,FALSE,NULL);
   unlink("c:\\x.tmp");
}
