#ifndef _CONTROL_H_
#define _CONTROL_H_

#define JOY_NONE        0
#define JOY_2BUTTON     1
#define JOY_4BUTTON     2
#define JOY_6BUTTON     3
#define JOY_8BUTTON     4
#define JOY_SIDEWIND    5
#define JOY_GAMEPADPRO  6
#define JOY_PSXPAD      7

#define NO_JOY_CONFIGS  20

typedef struct joysetupTAG
{
   char szIdent[16];
   char szName[16];
   int   idx;
} JOYSETUP;
typedef JOYSETUP *pJOYSETUP;

#define SETJOYBUTTON(x) \
   if(joydef[ x ].idx!=-1) \
      keys[joydef[ x ].idx]=1;

#define JOY2_DIR  (K_UP2*joyidx)
#define JOY2_BUT  (joyidx*10);
#define JOYMOVE   JoyMove=TRUE;

void getjoysticksetup(void);
void getjoyidx(pJOYSETUP pJoySetup);
void checkcontroller(void);
void calibratejoy(void);
int handlejoystick(void);

void readstandardjoy(void);
void readsidewinder(void);
void readgamepadpro(void);
void readpsxpad(void);

void setgenjoy(unsigned long int inval,int joyidx,unsigned long int *dirs,unsigned long int *buts);
void setupjoyvals(void);
int setupjoymenu(int n);
void updatejoys(void);
void movement(int *value,int page);
void checkwhichplayer(int idx);
void whichplayer(int idx);
int startpressed(void);
void setstart(void);
int p2button1(void);

#endif
