#ifndef _FIL_H_
#define _FIL_H_

#define  NEOGEO         "neogeo"

#define RMSFORMAT       "RMS32BIT5"
#define RMSFORMAT1      "RMS32BIT4"

#define	RMS_HEAD_SIZE	10

void openlogfile(void);
void closelogfile(void);
char *getlogstamp(char *szOut);
void makefullpath(char *szIn,char *szOut,int nEmu);
void checkrmsfiles(void);
void convertrmsfile(char *szName,char *szHeader);
void getrmsfile(char *in);
int makegamelist(pGETFILE pGameFiles,int *pNoGames,int MaxGames);
int readinival(char *szIdent,char *out,int nBSize,int nEmu);
void safecopy(char *dest,char *src,int nlen);
int safenum(char *in);
int setconfigfile(int bEmuIni,int nEmu,char *out);
void changeslash(char *path);
int gotconfig(char *line,char *ident);
void writeemucfg(int bVirtual,int startstop);
int checkfile(char *szfile);
void checkpath(char *path);
void writecfgfile(int NoValues);
int getallfiles(pGETFILE pFiles,int *pNoGames,char *szPattern,int attrib,int nGameType,int romdir,int maxfiles);  // LasVegas - Added romdir
int dupfile(char *szName,pGETFILE pGetFiles,int ngames);
int dupfilesort(char *szName,pGETFILE pGetFiles);
void addtextcfg(char *szIdent,char *szValue,int *pNoCfgValues);
void addexecfg(int *pNoCfgValues);
void setupexe(int xindex);
int getdefcfgvals(void);
int getitemcount(char *in,char sep);
char *getitem(char *out,char *in,int nindex,int bsize,char sep);
int readcfgvals(void);
void getemuvalue(char *buffer,char *out,int bufsize,int nEmu);
char *trimspaces(char *in);
int sort_function( const void *a, const void *b);
int sort_function2( const void *a, const void *b);

char *tidyget(char *inbuff,int len,FILE *f);
char *stripget(char *inbuff,int len,FILE *f);
char *getquickitem(char *in,int nindex,char sep,int *pLen);
int strcmpi(char *s1,char *s2);
void localinifile(char *buffer);
void fopenRM(int RMfileno);
void fprintfRM(char *buffer,...);
void fcloseRM(void);
void getcrc32(char *fname,char *crc);
unsigned int aoscrc32(unsigned int crc,pBYTE buf,unsigned int len);
char getfiledrive(void);
void loginfo(int level,char *buffer,...);
void progress(void);
int readlocalcfg(void);
void writelocalcfg(void);

#endif
