#ifndef _GLIST_H_
#define _GLIST_H_

#define MAX_GAMES   6000

#define GAME_LIST_SIZE  (sizeof(MAMEGAME)*MAX_GAMES)

#define	NEOGEO_LIST		"neogeo.lst"
#define	MAME_LIST		"mame.lst"
#define	CLONE_LIST		"clone.lst"

typedef struct quickcheckTAG
{
	char GameName[12];
	fpos_t	filepos;
} QUICKCHECK;
typedef QUICKCHECK * pQUICKCHECK;

typedef struct controldescTAG
{
   char *pIdent;
   int *pValue;
} CONTROLDESC;
typedef CONTROLDESC * pCONTROLDESC;

#define FILTER_SET(x,y) ( x > FILT_##y##_OFFSET)
#define FILTER_BASE(x,y) work = ( x - FILT_##y##_OFFSET );
#define FILTER_FAIL \
   { \
      *pWant=FALSE; \
      return; \
   }

int checkcontrolfilter(pMAMEDESC pMameDesc);
void getexeinfo(char *szName,char *szOut);
int getnamelist(char *pNeoList,char *szFile,long maxsize);
int isneogeo(char *szName,char *pNeoList);
int createlist(int *pNoGames,int nDispRot,int LastGame);
void writegamelist(int nGames);
void readgamelist(int nDispRot);
int makermsfile(pGETFILE pGetFiles,int NoFound,char *pNeoText);
int rmsexist(char *szName,pMAMEGAME pGame,FILE *fin,pQUICKCHECK pQuickChecks,int NoChecks);
char *getclones(char *szName,char *pGameText,char *szClone);
int addgame(pGETFILE pGetFile,pMAMEGAME pGame,FILE *fRMS,FILE *fNew,pQUICKCHECK pQuickChecks,int NoChecks,char *pNeoText);
void tablecom(char *szCom);
int quickread(char *szName);
int addlongnames(pGETFILE pGetFiles,int nGames,char *pGameText,char *pCloneText);
void getrealname(pGETFILE pGetFile,char *pGameList);
int longsort(const void *a, const void *b);
void makenice(char *szIn);
void setautocustom(pMAMEGAME pGame,int CustIdx);
void checkfilter(pMAMEDESC pMameDesc,int *pWant);
void getres(char *szRes,int *pX,int *pY);

#endif
