#ifndef _GLOBALS_H_
#define _GLOBALS_H_

#ifndef _MAIN_FILE_

extern   char  szMonitorMode[128];
extern	WINSTRUCT	gamewin;
extern	WINSTRUCT	cfgwin;
extern	WINSTRUCT	emuwin;
extern	int ConfigPos;
extern	int ConfigOff;
extern   int AllowVesa;

extern	ORIENT		ScreenOrient;
//flags
extern   int   CurEmu;
extern   int   InCabinet;
extern   int   noScanLines;
extern	int	ReRun;
extern	int	bDefMameDir;
extern	int	CurPos;
extern   int   OffSet[MAX_EMUS];
extern   int   nOrient[MAX_EMUS];
extern   int   bFirstSubControl;

extern	int 		NoGames;
extern	pMAMEGAME 	pMameGames;

//our screen
extern	pBYTE		screen;
extern	int			NoCfgValues;
extern   char        pszTextValues[][16];
extern	CFGVALUE	cfgDefValues[MAX_CFGS];
extern	short int	nCfgValues[MAX_CFGS];
extern	int			nNoTextVals;
extern   int         DispRot[MAX_EMUS];
extern	EMULATOR	Emulators[MAX_EMUS];

extern	int	nNoEmulators;
extern	int	BackColour;
extern	int	ForeColour;
extern	int	ExtraColour;
extern	PCXSTRUCT	pcxback;
extern	int	bGotBack;
extern	int	CursorColour;
extern	int	CloneColour;
extern	int	noExplodeWin;
extern   int   noMergedROMs[MAX_EMUS];
extern	int	noUseLastShot;
extern	int	Transparent;
extern	int	Information;
extern	int	noUnknowns;
extern	int	WinColour;
extern	int	FontShadow;
extern	int	noInstantStart;
extern	int	bHasMouse;
extern	int	nMouseType;
extern	BYTE 	keys[NO_OF_KEYS];
extern	int	MouseX;
extern	int	MouseY;
extern	int	*pStdPos;
extern	int	*pStdMax;
extern	int	MouseEvent;
extern	int	DisColour;
extern   int   nLastGame[MAX_EMUS];
extern   int   CustomList[MAX_EMUS];
extern	int	CustNeo;
extern	int	noShowCommand;
extern	int	noHideWarnings;
extern	int	nLogging;
extern	FILE	*fLogFile;
extern	int	nLogDate;
extern	int	nClearLog;
extern	int	noAutoDisable;
extern	int	nAutoRotate;
extern	int	noEasyCenter;
extern	int	nCenterX;
extern	int	nCenterY;
extern	int	SSInfo;  // EEA Changed these 2 from noAltSS...
extern	int	SSRun;   // EEA
extern	int	noAltSSRun;
extern	int	CustVector;
extern	int	noShowRun;
extern	short	DataSeg;
extern	short	CodeSeg;
extern	short	DosDataSeg;
extern	int	ExeIndex;
extern	int	Hires;
extern	int	WindowsDPMI;
extern char szStartDir[];
extern int RunningGame;
extern char szReturnGame[];
extern int MouseDrivX;
extern int MouseDrivY;
extern int noMouseTrails;
extern int ArcadeH;
extern int ArcadeV;
extern int PalH;
extern int PalV;
extern int ScanH;
extern int ScanV;
extern int noScaleToFit;
extern int JukeBoxSave;
extern int SaverCount;
extern int MouseSensX;
extern int MouseSensY;
extern int MickeyY;
extern int noflipx;
extern int noflipy;
extern int AutoRepeat;
extern int JukeDelay;
extern int EmuPos;
extern int EmuOffset;
extern int noStart12Esc;
extern BYTE scancodes[NO_OF_KEYS];
extern int WinTrans;
extern SCHEME schemes[MAX_SCHEMES];
extern int Scheme;
extern int noRotatePics;
extern int JoyType;
extern int ShiftKey;
extern int PrintHardware;
extern int ExtHardware;

extern char szTurnOff[512];
extern char szTurnOn[512];

extern int SubControlPos;
extern int SubControlItems;

extern int noUseCRC;
extern int SaverSSType;
extern int StartLastGame;
extern int RunState;

extern int ShotDelay;

extern clock_t clocks_per_second;
extern char *subitem;
extern int nDblClick;
extern int noSwapMouse;
extern int Nag;
extern int MameLegacy;
extern int DisableImperfect;
extern int SupportedSVGA;
extern int SBSound;
extern int vol;

extern char szSamples[][16];
extern int sampvol[6];
extern int sampfreq[6];

extern int nFileDrive;

extern int noWrapMenus;
extern int autorunninggame;
extern int SSPosition;

extern int noExtArcade;
extern int noSkipSizeCheck;
extern int TempDrive;
extern int BIOSCab;
extern char szMonOptions[][512];
extern int PlayerControl;
extern int noCocktailMode;
extern int FlipDelay;
extern int PlayerControl;
extern int noShiftKeys;
extern int TintType;
extern int Capitalise;

extern int nGameIndex;
extern int nSaveIndex;
extern int State;
extern int bFirstConfig;
extern int bExplodeConfig;
extern int FontSize;
extern int NoSaveCfgs;
extern pCFGVALUE pcfgSave;
extern int nWidthIndex;
extern int *pWidthVar;
extern int SavedNoMR;
extern int SavedUNK;
extern int ShadowHires;
extern int SavedNeo;
extern int SavedVector;
extern int SavedCapitalise;
extern int SavedSL;

extern int LongNames;

extern int noCustomContainsAll[MAX_EMUS];
extern int SavedNoCustomAll;

extern int noFiltersActive;
extern int SavedNoFiltActive;
extern int minfiltplayers[NO_CUSTOM_LISTS];
extern int maxfiltplayers[NO_CUSTOM_LISTS];
extern int minfiltyear[NO_CUSTOM_LISTS];
extern int maxfiltyear[NO_CUSTOM_LISTS];
extern int minfiltfreq[NO_CUSTOM_LISTS];
extern int maxfiltfreq[NO_CUSTOM_LISTS];
extern int minfiltcoin[NO_CUSTOM_LISTS];
extern int maxfiltcoin[NO_CUSTOM_LISTS];
extern int minfiltx[NO_CUSTOM_LISTS];
extern int maxfiltx[NO_CUSTOM_LISTS];
extern int minfilty[NO_CUSTOM_LISTS];
extern int maxfilty[NO_CUSTOM_LISTS];
extern int filtjoy2way[NO_CUSTOM_LISTS];
extern int filtjoy4way[NO_CUSTOM_LISTS];
extern int filtjoy8way[NO_CUSTOM_LISTS];
extern int filtdoublejoy2way[NO_CUSTOM_LISTS];
extern int filtdoublejoy4way[NO_CUSTOM_LISTS];
extern int filtdoublejoy8way[NO_CUSTOM_LISTS];
extern int filtpaddle[NO_CUSTOM_LISTS];
extern int filtdial[NO_CUSTOM_LISTS];
extern int filttrackball[NO_CUSTOM_LISTS];
extern int filtstick[NO_CUSTOM_LISTS];
extern int maxfiltbuttons[NO_CUSTOM_LISTS];
extern int minfiltbuttons[NO_CUSTOM_LISTS];
//extern int maxfiltdepth[NO_CUSTOM_LISTS];    // LasVegas - Removed ColorDepth Filter.
//extern int minfiltdepth[NO_CUSTOM_LISTS];    // LasVegas - Removed ColorDepth Filter.
extern int filthorz[NO_CUSTOM_LISTS];
extern int filtvert[NO_CUSTOM_LISTS];
extern int filtvector[NO_CUSTOM_LISTS];
extern int filtraster[NO_CUSTOM_LISTS];
extern int filtrom[NO_CUSTOM_LISTS];           // LasVegas - Added ROM Folder Filter

extern int soundcard;
extern int samplerate;

// DANNY REGO
extern int bLCDScreen;
extern int nLCDPort;
extern int nLCDMode;
extern char szLCDShutdown[16];

#endif

#endif
