#ifndef _SCREEN_H_
#define _SCREEN_H_

#define  HTOT  1
#define  HRS   5
#define  HRE   6
#define	VTOT	7

#define X_BYTE       640
#define X_QUAD       160
#define SCREEN_START 0xa0000
#define SCREEN_END   (0xa0000+(winpagesize*4))
#define SCREEN_CHECK (SCREEN_END-X_BYTE)
#define SCANLINE     (!noScanLines&&(y&1))

#define ASSIGN_PWORK pWork=(unsigned char *)pData;

#define BLIT_X_LINE  \
   for(x=0;x<160;x++) \
   {

#define BLIT_FLIPX \
   _farpokel(_dos_ds, saddress, lout); \
   saddress+=4; \
   if(saddress>=SCREEN_END) \
   { \
      n++; \
      setsvgapage(n); \
      saddress=SCREEN_START; \
   } \
   pData--; \
   pWork-=4; \
   }

#define BLIT_FLIPX_NOCHECK \
   _farpokel(_dos_ds, saddress, lout); \
   saddress+=4; \
   pData--; \
   pWork-=4; \
   }


#define BLIT_FLIPXY \
   _farpokel(_dos_ds, saddress, lout); \
   saddress+=4; \
   if(saddress>=SCREEN_END) \
   { \
      n++; \
      setsvgapage(n); \
      saddress=SCREEN_START; \
   } \
   pData--; \
   pWork-=4; \
   }


#define BLIT_FLIPXY_NOCHECK \
   _farpokel(_dos_ds, saddress, lout); \
   saddress+=4; \
   pData--; \
   pWork-=4; \
   }


#define BLIT_FLIPY \
   _farpokel(_dos_ds,saddress,lout); \
   pWork+=4; \
   saddress+=4; \
   }


#define DIM_QUAD        lout=(DimPalette[pWork[0]]<<24)|(DimPalette[pWork[1]]<<16)|(DimPalette[pWork[2]]<<8)|(DimPalette[pWork[3]]);
#define NORMAL_QUAD     lout=(pWork[0]<<24)|(pWork[1]<<16)|(pWork[2]<<8)|(pWork[3]);
#define DIM_YFLIP_QUAD  lout=(DimPalette[pWork[0]])|(DimPalette[pWork[1]]<<8)|(DimPalette[pWork[2]]<<16)|(DimPalette[pWork[3]]<<24);

typedef struct modeinfoTAG
{
   unsigned short ModeAttributes;
   unsigned char  WinAAttributes;
   unsigned char  WinBAttributes;
   unsigned short WinGranularity;
   unsigned short WinSize;
   unsigned short WinASegment;
   unsigned short WinBSegment;
   unsigned long  WinFuncPtr;
   unsigned short BytesPerScanLine;
   unsigned short XResolution;
   unsigned short YResolution;
   unsigned char  XCharSize;
   unsigned char  YCharSize;
   unsigned char  NumberOfPlanes;
   unsigned char  BitsPerPixel;
   unsigned char  NumberOfBanks;
   unsigned char  MemoryModel;
   unsigned char  BankSize;
   unsigned char  NumberOfImagePages;
   unsigned char  Reserved_page;
   unsigned char  RedMaskSize;
   unsigned char  RedMaskPos;
   unsigned char  GreenMaskSize;
   unsigned char  GreenMaskPos;
   unsigned char  BlueMaskSize;
   unsigned char  BlueMaskPos;
   unsigned char  ReservedMaskSize;
   unsigned char  ReservedMaskPos;
   unsigned char  DirectColorModeInfo;

   /* VBE 2.0 extensions */
   unsigned long  PhysBasePtr;
   unsigned long  OffScreenMemOffset;
   unsigned short OffScreenMemSize;

   /* VBE 3.0 extensions */
   unsigned short LinBytesPerScanLine;
   unsigned char  BnkNumberOfPages;
   unsigned char  LinNumberOfPages;
   unsigned char  LinRedMaskSize;
   unsigned char  LinRedFieldPos;
   unsigned char  LinGreenMaskSize;
   unsigned char  LinGreenFieldPos;
   unsigned char  LinBlueMaskSize;
   unsigned char  LinBlueFieldPos;
   unsigned char  LinRsvdMaskSize;
   unsigned char  LinRsvdFieldPos;
   unsigned long  MaxPixelClock;

   unsigned char  Reserved[190];
} MODEINFO;

int getmodeinfo(int mode);
void centermode(char,char);
void putsvga(void);
void setsvgapage(int page);
void fastback(void);
void fastbackact(pBYTE source,pBYTE dest,short seg,int ssize);
void clrcrtcprot(void);
void settiming(void);
void putflipxy(pBYTE pData,short seg);
void putflipx(pBYTE pData,short seg);
void putflipy(pBYTE pData,short seg);
void putvesaflipxy(void);
void putvesaflipx(void);
void putvesaflipy(void);
void setarcademode(void);

#endif
