#include "main.h"
#include "keyasm.h"
#include "emu.h"
#include "launch.h"
#include "winchar.h"
#include "disp.h"


WINSTRUCT	wsTopWindow;

int   MDwnX;
int   MDwnY;


void initwindow(void)
{
	memset(&wsTopWindow,0,sizeof(WINSTRUCT));
}

void registerwindow(pWINSTRUCT pWinStruct)
{
	pWinStruct->onclose=FALSE;
	pWinStruct->xmul=0;
	pWinStruct->ymul=0;
	pWinStruct->xoff=0;
	pWinStruct->yoff=0;
   memcpy(&wsTopWindow,pWinStruct,sizeof(WINSTRUCT));
}

void sendmessage(int Message)
{
	int	x,y,xmul,ymul;
	int	nx1,ny1,nx2,ny2,temp;
	int xoff,yoff;

	if(wsTopWindow.winproc)
	{

		x=wsTopWindow.xtopleft;
		y=wsTopWindow.ytopleft;
		getrealxy(&x,&y,&xmul,&ymul,&xoff,&yoff,WIN_FONT);
		nx1=x*xmul;
		ny1=y*ymul;
		nx1+=xoff;
		ny1+=yoff;

		x=wsTopWindow.xbotright;
		y=wsTopWindow.ybotright;
		getrealxy(&x,&y,&xmul,&ymul,&xoff,&yoff,WIN_FONT);
		nx2=x*xmul;
		ny2=y*ymul;
		nx2+=xoff;
		ny2+=yoff;


		onwinclose(nx1,nx2,ny1,ny2,MouseX,MouseY,xmul,ymul);

		if(nx2<nx1)
		{
			temp=nx1;
			nx1=nx2;
			nx2=temp;
		}
		if(ny2<ny1)
		{
			temp=ny1;
			ny1=ny2;
			ny2=temp;
		}

//is mouse in there
    	if(MouseX>=nx1&&MouseY>=ny1&&MouseX<=nx2&&MouseY<=ny2)
		{
			getrotmouse(MouseX,MouseY,&x,&y);
			switch(ScreenOrient.Orientation)
			{
				case	1:
				case	2:
					wsTopWindow.xmul=ymul;
					wsTopWindow.ymul=xmul;
					wsTopWindow.xoff=ScreenOrient.ywinoff;
					wsTopWindow.yoff=ScreenOrient.xwinoff;
					wsTopWindow.clienty=(16+wsTopWindow.xoff+(wsTopWindow.ytopleft*xmul));

					break;
				default:
					wsTopWindow.xmul=xmul;
					wsTopWindow.ymul=ymul;
					wsTopWindow.xoff=ScreenOrient.xwinoff;
					wsTopWindow.yoff=ScreenOrient.ywinoff;
					wsTopWindow.clienty=(16+wsTopWindow.yoff+(wsTopWindow.ytopleft*ymul));
					break;
			}
			(*wsTopWindow.winproc)(Message,x,y,(void *)&wsTopWindow);
		}
	}
}

void onwinclose(int xa,int xb,int ya,int yb,int mx,int my,int xmul,int ymul)
{
   int   nx1,nx2,ny1,ny2,xext1,xext2;
	wsTopWindow.onclose=FALSE;

	switch(ScreenOrient.Orientation)
	{
		case	1:
			nx1=xa+4;
			nx2=nx1+7;
			ny2=yb+(ymul*2);
			ny2-=2;
			ny1=ny2-7;
         xext1=yb;
         xext2=ya;
			break;
		case	2:
			nx1=xa-11;
			nx2=nx1+7;
			ny1=yb-(ymul*2);
			ny1+=2;
			ny2=ny1+7;
         xext1=ya;
         xext2=yb;
			break;

		default:
			nx1=xb-(xmul*2);
			nx1+=2;
			ny1=ya+4;
			nx2=nx1+7;
			ny2=ny1+7;
         xext1=xa;
         xext2=xb;
			break;
	}


	if(mx>=nx1&&mx<=nx2&&my>=ny1&&my<=ny2)
		wsTopWindow.onclose=TRUE;
}

void getrotmouse(int inx,int iny,int *outx,int *outy)
{

	switch(ScreenOrient.Orientation)
	{
		case 1:
			*outy=inx;
			*outx=(191-iny);
			break;

		case 2:
			*outx=iny;
			*outy=(311-inx);
			break;
		default:
			*outx=inx;
			*outy=iny;
	}

}

void cfgproc(int Message,int Data1,int Data2,void *pData)
{
	pWINSTRUCT	pWinStruct;
	int	nsel,nfarright,nbotright;
	cfgwin.control=0;

	if(nMouseType!=STANDARD_MOUSE)
		return;

	pWinStruct=(pWINSTRUCT)pData;

	switch(ScreenOrient.Orientation)
	{
		case 1:
		case 2:
			nfarright=pWinStruct->yoff+(pWinStruct->xbotright*pWinStruct->xmul);
			nbotright=(pWinStruct->xoff+(pWinStruct->ybotright*pWinStruct->ymul)-pWinStruct->clienty);
			break;
		default:
			nfarright=pWinStruct->xoff+(pWinStruct->xbotright*pWinStruct->xmul);
			nbotright=(pWinStruct->yoff+(pWinStruct->ybotright*pWinStruct->ymul)-pWinStruct->clienty);

	}

	nsel=Data2-pWinStruct->clienty;
	cfgwin.xoff=pWinStruct->xoff;
	cfgwin.yoff=pWinStruct->yoff;
	cfgwin.clienty=pWinStruct->clienty;


	switch(Message)
	{
		case	WM_LDOWN:
			if(Data1<(nfarright-15))
			{
				if(nsel>=0)
				{
               nsel/=ScreenOrient.fy;
					if(nsel<ScreenOrient.NoOnScreen)
						ConfigPos=nsel+ConfigOff;
				}
			}
         handlescroll(Data1,nfarright,nbotright,&cfgwin,nsel,8,Message);


			break;
		case WM_LUP:
//see if it's on our exit box
			if(upokay())
			{
				if(pWinStruct->onclose)
					keys[K_START2]=1;
				handlescroll(Data1,nfarright,nbotright,&cfgwin,nsel,8,Message);
			}
			break;
		case WM_LDBLCLICK:
         setstart();

	}
}

void emuproc(int Message,int Data1,int Data2,void *pData)
{
	pWINSTRUCT	pWinStruct;
	int	nsel,nfarright,nbotright;
	emuwin.control=0;

	if(nMouseType!=STANDARD_MOUSE)
		return;

	pWinStruct=(pWINSTRUCT)pData;

	switch(ScreenOrient.Orientation)
	{
		case 1:
		case 2:
			nfarright=pWinStruct->yoff+(pWinStruct->xbotright*pWinStruct->xmul);
			nbotright=(pWinStruct->xoff+(pWinStruct->ybotright*pWinStruct->ymul)-pWinStruct->clienty);
			break;
		default:
			nfarright=pWinStruct->xoff+(pWinStruct->xbotright*pWinStruct->xmul);
			nbotright=(pWinStruct->yoff+(pWinStruct->ybotright*pWinStruct->ymul)-pWinStruct->clienty);

	}

	nsel=Data2-pWinStruct->clienty;
	emuwin.xoff=pWinStruct->xoff;
	emuwin.yoff=pWinStruct->yoff;
	emuwin.clienty=pWinStruct->clienty;


	switch(Message)
	{
		case	WM_LDOWN:
			if(Data1<(nfarright-15))
			{
				if(nsel>=0)
				{
					nsel/=pWinStruct->ymul;
					if(nsel<ScreenOrient.NoOnScreen)
						EmuPos=nsel+EmuOffset;
				}
			}
         handlescroll(Data1,nfarright,nbotright,&emuwin,nsel,16,Message);


			break;
		case WM_LUP:
//see if it's on our exit box
			if(upokay())
			{
				if(pWinStruct->onclose)
					keys[K_START2]=1;
				else
					handlescroll(Data1,nfarright,nbotright,&emuwin,nsel,8,Message);
			}
			break;
		case WM_LDBLCLICK:
			if(Data1<(nfarright-15)||!emuwin.bHasScrollBar)
            setstart();

	}
}


void stdproc(int Message,int Data1,int Data2,void *pData)
{
	pWINSTRUCT	pWinStruct;
	int   nsel,nin=0;

	if(nMouseType!=STANDARD_MOUSE)
		return;

	pWinStruct=(pWINSTRUCT)pData;

	if(pStdPos)
		nin=stdselect(Data2,pWinStruct,*pStdPos,*pStdMax,&nsel);

	switch(Message)
	{
		case	WM_LDOWN:
			if(pStdPos)
				*pStdPos=nin;
			break;
		case WM_LUP:
			if(upokay())
			{
//see if it's on our exit box
				if(pWinStruct->onclose)
					keys[K_START2]=1;
			}

			break;
		case WM_LDBLCLICK:
			if(pStdPos)
				if(nsel>=0&&nsel<*pStdMax)
               setstart();

			break;
	}
}
void gamesproc(int Message,int Data1,int Data2,void *pData)
{
	pWINSTRUCT	pWinStruct;
	int	nsel,nfarright,nbotright,nitem;
	static	int	ldown=FALSE;

	pWinStruct=(pWINSTRUCT)pData;
	gamewin.control=0;

	if(nMouseType!=STANDARD_MOUSE)
		return;

	switch(ScreenOrient.Orientation)
	{
		case 1:
		case 2:
			nfarright=pWinStruct->yoff+(pWinStruct->xbotright*pWinStruct->xmul);
			nbotright=(pWinStruct->xoff+(pWinStruct->ybotright*pWinStruct->ymul)-pWinStruct->clienty);
			break;
		default:
			nfarright=pWinStruct->xoff+(pWinStruct->xbotright*pWinStruct->xmul);
			nbotright=(pWinStruct->yoff+(pWinStruct->ybotright*pWinStruct->ymul)-pWinStruct->clienty);

	}

	nsel=Data2-pWinStruct->clienty;
	gamewin.clienty=pWinStruct->clienty;
	gamewin.xoff=pWinStruct->xoff;
	gamewin.yoff=pWinStruct->yoff;

   nitem=nsel/ScreenOrient.fy;
	switch(Message)
	{
		case WM_LDOWN:
			if(Data1<(nfarright-15)||!gamewin.bHasScrollBar)
			{
				if(!ldown)
				{
					if(nsel>=0)
					{
                  if(nitem<ScreenOrient.NoOnScreen&&(nitem+OffSet[CurEmu])<Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION])
                     CurPos=nitem+OffSet[CurEmu];
					}
				}
			}
         handlescroll(Data1,nfarright,nbotright,&gamewin,nsel,8,Message);
			ldown=TRUE;

			break;
		case WM_LUP:
			ldown=FALSE;
			if(upokay())
			{
//see if it's on our exit box
				if(pWinStruct->onclose)
					keys[K_ESC]=1;
				handlescroll(Data1,nfarright,nbotright,&gamewin,nsel,8,Message);
			}

			break;
		case WM_RDOWN:
			if(Data1<(nfarright-15))
			{
            if(nsel>=0&&Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION])
				{

               if(nitem<ScreenOrient.NoOnScreen&&(nitem+OffSet[CurEmu])<Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION])
					{
                  CurPos=nitem+OffSet[CurEmu];
                  if(CurPos>=Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION])
                     CurPos=Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]-1;
					}
				}
			}

			keys[K_START2]=1;
			break;
		case WM_LDBLCLICK:
			if(Data1<(nfarright-15)||!gamewin.bHasScrollBar)
			{
            if(nitem<ScreenOrient.NoOnScreen&&(nitem+OffSet[CurEmu])<Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION])
               setstart();
			}
			break;
	}
}


void handlescroll(int Data1,int nfarright,int nbotright,pWINSTRUCT pgamewin,int nsel,int botbutt,int message)
{
	int	nscroll;

   char szOut[256];
	if(!pgamewin->bHasScrollBar||nMouseType!=STANDARD_MOUSE)
		return;

   switch(ScreenOrient.Orientation)
	{
		case 1:
		case 2:
			nscroll=(pgamewin->scrollpos+(pgamewin->xoff))-pgamewin->clienty;
			break;
		default:
			nscroll=(pgamewin->scrollpos+(pgamewin->yoff))-pgamewin->clienty;
	}



   pgamewin->NewScrollPos=nsel;
	if(Data1>(nfarright-12)&&Data1<(nfarright-4))
	{
		if(nsel>=0&&nsel<=8)
		{
         pgamewin->ScrollDrag=WM_SCROLLDRAG_NONE;
         if(message==WM_LDOWN)
			{
				keys[K_UP]=1;
				pgamewin->control|=CTRL_SCROLLUP;
			}
		}
		else
		{

         if(nsel>=(nscroll-4)&&nsel<=(nscroll+12))
         {
            if(message==WM_LDOWN)
            {
               switch(pgamewin->ScrollDrag)
               {
                  case WM_SCROLLDRAG_NONE:

                     pgamewin->ScrollDrag=WM_SCROLLDRAG_START;
                     pgamewin->ScrollOffset=nsel-nscroll;
                     pgamewin->LastScrollPos=nsel;
                     break;
                  case WM_SCROLLDRAG_START:
                     pgamewin->ScrollDrag=WM_SCROLLDRAG_DRAGGING;
                     break;
               }
            }
            else
            {
               if(message==WM_LUP)
                  pgamewin->ScrollDrag=WM_SCROLLDRAG_NONE;
            }
         }
         else
         {
            if(message==WM_LUP)
               pgamewin->ScrollDrag=WM_SCROLLDRAG_NONE;


            if(nsel>=(nbotright-(botbutt+8))&&nsel<=(nbotright-botbutt))
            {
               if(message==WM_LDOWN)
               {
                  keys[K_DOWN]=1;
                  pgamewin->control|=CTRL_SCROLLDOWN;
               }
            }
            else
            {
               if(message==WM_LUP)
               {
                  if(upokay())
                  {
                     if(nsel<=nscroll&&nsel>0)
                     {
                        keys[K_LEFT]=1;
                        pgamewin->flashup=1;
                     }
                     if(nsel>=nscroll+8)
                     {
                        keys[K_RIGHT]=1;
                        pgamewin->flashdown=1;
                     }
                  }
               }
            }
         }
		}
	}
   if(Data1<(nfarright-24)||Data1>(nfarright))
      pgamewin->ScrollDrag=WM_SCROLLDRAG_NONE;

   if(nsel<=8)
      pgamewin->ScrollDrag=WM_SCROLLDRAG_NONE;

   if(nsel>=(nbotright-(botbutt+8)))
      pgamewin->ScrollDrag=WM_SCROLLDRAG_NONE;



   switch(ScreenOrient.Orientation)
	{
		case 1:
		case 2:
			nscroll=(pgamewin->scrollpos+(pgamewin->xoff))-pgamewin->clienty;
			break;
		default:
			nscroll=(pgamewin->scrollpos+(pgamewin->yoff))-pgamewin->clienty;
	}

}


int stdselect(int my,pWINSTRUCT pWinStruct,int cpos,int max,int *pnsel)
{
	*pnsel=my;
	*pnsel-=pWinStruct->clienty;
	if(*pnsel>=0)
	{
      *pnsel/=ScreenOrient.fy;
		if(*pnsel>=0&&*pnsel<max)
		{
			cpos=*pnsel;
		}
	}
	return cpos;
}

void createwin(pWINSTRUCT pWinStruct,int x,int y,int w,int h,int woff,int hoff)
{
    pWinStruct->xtopleft=(x*ScreenOrient.fx)/6;
    pWinStruct->ytopleft=(y*ScreenOrient.fy)>>3;
    pWinStruct->xbotright=(pWinStruct->xtopleft+((w*ScreenOrient.fx)/6))+woff;
    pWinStruct->ybotright=(pWinStruct->ytopleft+((h*ScreenOrient.fy)>>3))+hoff;
}

int upokay()
{
	if((MouseX-MDwnX)>-4&&(MouseX-MDwnX)<4)
		if((MouseY-MDwnY)>-4&&(MouseY-MDwnY)<4)
			return TRUE;
	return FALSE;
}

