#ifndef _WIN_H_
#define _WIN_H_

#define WM_LDBLCLICK   4
#define WM_RDBLCLICK   5
#define WM_MDBLCLICK   6
#define WM_LDOWN       7
#define WM_RDOWN       8
#define WM_MDOWN       9
#define WM_LUP         10
#define WM_RUP         11
#define WM_MUP         12
#define WM_DRAG        13

#define CTRL_SCROLLUP     1
#define CTRL_SCROLLDOWN   2

#define WM_SCROLLDRAG_NONE       0
#define WM_SCROLLDRAG_START      1
#define WM_SCROLLDRAG_DRAGGING   2
#define WM_SCROLLDRAG_END        3


typedef struct
{
	int	xtopleft;
	int	ytopleft;
	int	xbotright;
	int	ybotright;
	int	onclose;
	int	xmul;
	int	ymul;
   int   xoff;
   int   yoff;
	int	clientx;
	int	clienty;
	int	control;
	int	scrollpos;
	int	bHasScrollBar;
   int   ScrollDrag;
   int   LastScrollPos;
   int   NewScrollPos;
   int   ScrollOffset;
   int   flashup;
   int   flashdown;
	void (*winproc)(int Message,int Data1,int Data2,void *pData);
} WINSTRUCT;

typedef WINSTRUCT *pWINSTRUCT;

void initwindow(void);
void registerwindow(pWINSTRUCT pWinStruct);
void sendmessage(int Message);
void getrotmouse(int inx,int iny,int *outx,int *outy);
void onwinclose(int xa,int xb,int ya,int yb,int mx,int my,int xmul,int ymul);
void createwin(pWINSTRUCT pWinStruct,int x,int y,int w,int h,int woff,int hoff);
int upokay(void);

#endif
