#ifndef _CONFIG_H_
#define _CONFIG_H_

#define BUFFER_START       0
#define BUFFER_FOUND_IDENT 1
#define BUFFER_FOUND_EQUAL 2
#define BUFFER_FOUND_VALUE 3

typedef struct configitemTAG
{
   int *pvalue;
   char *comment;
   char *name;
   int defval;
   int offset;
   BYTE invert;
   BYTE cfgtype;
} CONFIGITEM ;

typedef CONFIGITEM *pCONFIGITEM;

typedef struct textitemTAG
{
   char *pvalue;
   char *comment;
   char *name;
   char *defval;
} TEXTITEM;
typedef TEXTITEM *pTEXTITEM;

void getcfgvalues(void);
void setdefvals(void);
void writecfgvalues(void);
int getcmdlineargs(int argc,char **argv);
void cmdlinehelp(void);
void tidybuffer(char *pin);
void saveinitconfig(int nTotal);
int configchanged(void);
void restoldconfig(void);
void setarcconfig(char *szMenu,char *szIdent,int *pOrig,int nType,int nMin,int nMax,int nIndex,int nOffSet,int cfgtype);
void setarcconfigdef(char *szMenu,char *szIdent,int *pOrig,int nType,int nMin,int nMax,int nIndex,int nOffSet,int cfgtype,int def);


#endif
