#include "main.h"

void _crit_handler(void);
void _crit_handler_end(void);
int	CritErr;

//install our critcial error handler
void initcrit(void)
{

	__dpmi_paddr addr;

	CritErr=0;
//lock the new handler
	_go32_dpmi_lock_code((void *)_crit_handler,(long)_crit_handler_end-(long)_crit_handler);
//then set the new one
	addr.selector = CodeSeg;
	addr.offset32 = (long)_crit_handler;
	__dpmi_set_protected_mode_interrupt_vector(0x24,&addr);

}

int readcrit(void)
{
	return CritErr;
}

void critclear(void)
{
	CritErr=0;
}


