#include "main.h"
#include "disp.h"

static char	szErrLine1[256];
static char	szErrLine2[256];

extern int PreErrState;
extern int State;
extern int bFirstError;
extern int bClear;

void generror()
{
   char buffer[64];
   sprintf(buffer,"Error Reading %c:",getfiledrive());
   seterror(buffer,"Or File Not Found");
}

void seterror(char *szLine1,char *szLine2)
{
	while(*szLine1&&isspace(*szLine1))
		szLine1++;
	while(*szLine2&&isspace(*szLine2))
		szLine2++;

	safecopy(szErrLine1,szLine1,ScreenOrient.maxx-3);
	safecopy(szErrLine2,szLine2,ScreenOrient.maxx-3);
	PreErrState=State;
	State=MENU_STATE_ERROR;
	bFirstError=TRUE;
	bClear=FALSE;
}
void disperror(void)
{
	WINSTRUCT	winstruct;
	int wide;

	wide=strlen(szErrLine1)+1;
	if((strlen(szErrLine2)+1)>wide)
		wide=strlen(szErrLine2)+1;

	if(Hires&&wide<29)
		wide=29;

   createwin(&winstruct,2,7,2+wide,8,0,0);
	winstruct.winproc=stdproc;
	winstruct.bHasScrollBar=FALSE;

	pStdPos=NULL;
	pStdMax=NULL;

	registerwindow(&winstruct);

	drawwindow(&winstruct,4,TRUE,FALSE,"Error");
	dispcentre(10,szErrLine1,ExtraColour,3,wide+2,FALSE,0,0,DISP_FONT);
	dispcentre(11,szErrLine2,ExtraColour,3,wide+2,FALSE,0,0,DISP_FONT);
	dispcentre(13,"Start 2 to Continue",ForeColour,2,wide+2,TRUE,0,0,DISP_FONT);
}


