#include "main.h"


int readjoystick(int NoJoys,int *buttons,int *xx1,int *yy1,int *xx2,int *yy2)
{
   int inval;
   int clicker=0;
   int mask;


   mask=3;
   *xx1=0;
   *xx2=0;
   *yy1=0;
   *yy2=0;
//only poll second joy if it exists
   if(NoJoys==2||JoyType==JOY_6BUTTON||JoyType==JOY_8BUTTON)
      mask=15;


   __asm volatile ("cli");

   outportb(0x201,0);

   while(TRUE)
   {
      inval=inportb(0x201);
      if(inval&1)
         *xx1+=1;
      if(inval&2)
         *yy1+=1;
      if(inval&4)
         *xx2+=1;
      if(inval&8)
         *yy2+=1;
//break if delay too big
      clicker++;
      if(clicker==0xffff)
         break;
//break if we got everything
      if(!(inval&mask))
         break;
   }
   __asm volatile ("sti");
//get buttons
   *buttons=inportb(0x201);

   return clicker;

}

int checkjoy(void)
{
   int dummy;
   switch(JoyType)
   {
      case JOY_2BUTTON:
         loginfo(1,"2 Button PC Joystick/pad selected");
         break;
      case JOY_4BUTTON:
         loginfo(1,"4 Button PC Joystick/pad selected");
         break;
      case JOY_6BUTTON:
         loginfo(1,"6 Button PC Joystick/pad selected");
         break;
      case JOY_8BUTTON:
         loginfo(1,"8 Button PC Joystick/pad selected");
         break;
   }

//check for 1 joystick
   if(readjoystick(1,&dummy,&dummy,&dummy,&dummy,&dummy)==0xffff)
   {
      loginfo(1,"NO PC Joystick/pad found");
      return 0;
   }
//if it's a 2button job,check for another one
   if(JoyType==JOY_2BUTTON)
   {
      if(readjoystick(2,&dummy,&dummy,&dummy,&dummy,&dummy)==0xffff)
      {
         loginfo(1,"1 PC Joystick/pad found");
         return 1;
      }
      else
      {
         loginfo(1,"2 PC Joystick/pads found");
         return 2;
      }
   }
   loginfo(1,"1 PC Joystick/pad found");
   return 1;
}

