#include	"main.h"
#include	"keyasm.h"
#include "key_lc.h"
#include  <sys/segments.h>


__dpmi_paddr old_vector;
void _akey_handler(void);
void _akey_handler_end(void);
BYTE scancodes[NO_OF_KEYS];
BYTE lowkeys[NO_OF_KEYS];

int	nAnyKey;

static int noscans;

static int copycodes[NO_OF_KEYS];

void setupkeyvals(void)
{
   int i;
   noscans=sizeof(scannames)/8;

   for(i=0;i<noscans;i++)
      strcpy(pszTextValues[KEY_OFFSET+i],scannames[i]);
}


int setupkeymenu(int n)
{
   int i;
   for(i=0;i<NO_OF_KEYS;i++)
   {
      copycodes[i]=((int)scancodes[i]+KEY_OFFSET);
      if(*dispkey[i])
         setarcconfig(dispkey[i],"",&copycodes[i],1,KEY_OFFSET,KEY_OFFSET+noscans,n++,0,CFG_INT);
   }

   return n;
}

void updatekeys(void)
{
   int i;
   for(i=0;i<NO_OF_KEYS-1;i++)
      scancodes[i]=((BYTE)copycodes[i]-KEY_OFFSET);
}

int setupshiftmenu(int n)
{
   int nodefs,i;
   nodefs=sizeof(dispshift)/16;

   for(i=0;i<nodefs;i++)
   {
      copycodes[i]=Emulators[CurEmu].cShiftChar[i]+KEY_OFFSET;
      setarcconfig(dispshift[i],"",&copycodes[i],1,KEY_OFFSET,KEY_OFFSET+noscans,n++,0,CFG_INT);
   }
   return n;
}

void updateshifts(void)
{
   int nodefs,i;
   nodefs=sizeof(dispshift)/16;

   for(i=0;i<nodefs;i++)
      Emulators[CurEmu].cShiftChar[i]=copycodes[i]-KEY_OFFSET;
}

void replace(void)
{
	__dpmi_paddr addr;
//lock the new handler
	_go32_dpmi_lock_code((void *)_akey_handler,(long)_akey_handler_end-(long)_akey_handler);
//get the old vector
	__dpmi_get_protected_mode_interrupt_vector(9,&old_vector);
//then set the new one
	addr.selector = CodeSeg;
	addr.offset32 = (long)_akey_handler;
	__dpmi_set_protected_mode_interrupt_vector(9,&addr);

}

void putback(void)
{
//set the old one back
	__dpmi_set_protected_mode_interrupt_vector(9,&old_vector);
}

void initkey(void)
{
	memset(lowkeys,0,NO_OF_KEYS);
	nAnyKey=0;
}

int readkey(void)
{
	int n,ret;
	ret=nAnyKey;
	nAnyKey=0;
	for(n=0;n<NO_OF_KEYS;n++)
	{
		keys[n]=lowkeys[n];
      ret|=keys[n];
	}
	return ret;
}

void stuffrets(void)
{
	__dpmi_regs r;
	int	n;
	for(n=0;n<2;n++)
	{
		r.h.ah=5;
		r.h.cl=13;
		r.h.ch=28;
		__dpmi_int(0x16, &r);
	}
}


void clearkbuff()
{
   _farpokew(_dos_ds, 0x41A, 0x001E);
   _farpokew(_dos_ds, 0x41C, 0x001E);
}

