#ifndef _LST_H_
#define _LST_H_

#define  STATE_LOOKING  0
#define	STATE_GOT		1

#define TEMPDRIVE 'C'+TempDrive

typedef struct
{
   char szFileName[256];
   char szDescription[256];
   char szCloneOf[256];
   char szResolution[256];
   char szControl[256];
   char szYear[256];
   char szMan[256];
   int nColors;
   int nFreq;
   int nRotated;
   int nOkay;
   int nClone;
   int nVector;
   int nPlayers;
   int nCoins;
   int nColorDepth;
   int nButtons;
   int nColorOK;
   int nHorizontal;
} MAMEDESC;

typedef MAMEDESC * pMAMEDESC;


int makelists(void);
int getdescgen(char *in,char *szName,char *out);
void getentry(char *in,char *out);
void getdescorient(char *in,pMAMEDESC pMameDesc);
void getintinfo(char *in,char *szIdent,int *val);
void getokinfo(char *in,char *szIdent,int *val);
void getdriverinfo(char *in,pMAMEDESC pMameDesc);
void getinputinfo(char *in,pMAMEDESC pMameDesc);

#endif
