#ifndef _SCRN_H_
#define _SCBN_H_

#define  PUZZ_NONE   -1
#define	PUZZ_UP		0
#define	PUZZ_DOWN   1
#define	PUZZ_LEFT	2
#define	PUZZ_RIGHT	3
#define	PUZZ_CHOOSE	4
#define	PUZZ_MOVE	5
#define	NO_OF_STARS	100
#define	BOX_LEN	40

typedef struct
{
	int	x;
	int	y;
	int	z;
} STAR;

typedef STAR *pSTAR;

typedef struct
{
    int x;
    int y;
    int xdir;
    int ydir;
    pBYTE scratch;
    pBYTE morph;
    short int *lensdata;
} LENSDATA;

typedef LENSDATA *pLENSDATA;

int screensaver(int type);
void lenssaver(void);
void dolens(pLENSDATA pLensData,int nolens);
int getlensdata(short int *lensdata);
void slidepuzzle(int pluslens);
void clearsquare(int x,int y);
void copysquare(int x,int y,pBYTE dest);
void drawsquare(int x,int y,pBYTE src);
void starfield(void);

void drawstar(pSTAR pstar,int nindex);
void sshots(int pluslens,int smear,int explode,int drawslats);
int keyorbutpres(void);
int jukebox(void);
void shots3d(void);
void blankscreen(void);
int getsstype(void);
int checkpicchange(void);

#endif
