#ifndef _SOUND_H_
#define _SOUND_H_

#define  SOUND_STARTUP  0
#define  SOUND_SHUTDOWN 1
#define  SOUND_WINDOW   2
#define  SOUND_ERROR    3
#define  SOUND_SAVER    4
#define  SOUND_GAME     5

#define  NO_CHANNELS    12
#define  NO_SAMPLES     32

#define  SOUND_UPDATE_INIT int snd_trip=0;

#define  SOUND_UPDATE_TRIP(x) \
   if(soundcard) \
   { \
      snd_trip++; \
      if(snd_trip== x ) \
      { \
         snd_trip=0; \
         updatesound(); \
      } \
   }

void updatesound(void);
int initsoundinterface(void);
void clearsoundinterface(void);
void soundinterface(int idx);
void beep(int nobeeps);
int readsample(char *szFileName,int waveno);
void sounddelay(int secs);

#endif
